package com.eactive.eai.agent.transformer;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.util.Logger;
import com.eactive.eai.transformer.transform.TransformManager;

public class ReloadTransformCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadTransformCommand() {
		super("ReloadTransformCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			TransformManager manager = TransformManager.getManager();

			String transformName = (String) args;
			if (transformName != null) {
				if ("ALL".equals(transformName)) {
					manager.reload();
					if (logger.isWarn())
						logger.warn("ReloadTransformCommand ] all Transform info Reload.");
				} else {
					manager.reload(transformName);
					if (logger.isWarn())
						logger.warn("ReloadTransformCommand ] " + transformName + " Transform info Reload.");
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//    public static void main(String[] args)throws Exception{
//        
//        TransformManager manager = TransformManager.getManager();
//        
//        Command command = new ReloadTransformCommand();
//        command.setArgs("");
//        AgentUtil.broadcast(command);
//        
//    }
}
